**************************************************************************
***               Module ansi : Gestion de l'affichage                ****
**************************************************************************

	include	declare.s
	xdef	initansi,locate
	xdef	clear,gras,normal,inverse,souligne,clignote

**************************************************************************
	sect	prog,,c

* Procdure locate :
* place le curseur sur la ligne y et la colonne x sur l'cran :
* y est le premier argument dans la pile, x le second (bytes).
* Le coin en haut  gauche est numrot y=1, x=1
locate	movem.l	d0-d2/a5,-(SP)

	move.b	22(SP),d1
	and.w	#$FF,d1
	jsr	div
 	move.b	d1,gotoxy+2
 	move.b	d0,gotoxy+3

	move.b	20(SP),d1
	and.w	#$FF,d1
	jsr	div
	move.b	d1,gotoxy+5
	move.b	d0,gotoxy+6

	lea	gotoxy,a5
	jsr	pdata

 	movem.l	(SP)+,d0-d2/a5
 	rts

* Procdure div : Prend le nombres d1.b comme argument
* Retourne les codes ascii des deux chiffres du nombres :
* le chiffre des dizaines dans d1.b, le chiffre des units dans d0.b
div	clr.l	d0
	move.b	d1,d0
	divu	#10,d0
	move.b	d0,d1
	swap	d0
	add.b	#$30,d0
	add.b	#$30,d1
	rts


* Initialisation : Recopie str_gotoxy dans gotoxy
initansi
	lea	gotoxy,a5
	lea	str_gotoxy,a0
	clr.b	d0
boucle	move.b	(a0,d0),d1
	move.b	d1,(a5,d0)
	add.b	#1,d0
	cmp.b	#4,d1
	bne	boucle
	rts

* Effacement de l'cran
clear	movem.l	d0/a5,-(SP)
	lea	str_clear,a5
	jsr	pdata
	movem.l (SP)+,d0/a5
	rts


* Affichage special

gras 	movem.l	d0/a5,-(SP)
	lea	str_gras,a5
	jsr	pdata
	movem.l (SP)+,d0/a5
	rts

normal	movem.l	d0/a5,-(SP)
	lea	str_normal,a5
	jsr	pdata
	movem.l (SP)+,d0/a5
	rts

inverse	movem.l	d0/a5,-(SP)
	lea	str_inverse,a5
	jsr	pdata
	movem.l (SP)+,d0/a5
	rts

souligne
	movem.l	d0/a5,-(SP)
	lea	str_souligne,a5
	jsr	pdata
	movem.l (SP)+,d0/a5
	rts

clignote
	movem.l	d0/a5,-(SP)
	lea	str_clignote,a5
	jsr	pdata
	movem.l (SP)+,d0/a5
	rts


************************************************************************
	sect	data,,d

* Sequence ansi
str_clear	dc.b '','[','2','J',04
str_gras	dc.b '','[','1','m',04
str_normal	dc.b '','[','0','m',04
str_inverse	dc.b '','[','7','m',04
str_souligne	dc.b '','[','4','m',04
str_clignote	dc.b '','[','5','m',04
str_gotoxy	dc.b '','[','0','0',';','0','0','H',04
gotoxy		ds.b 10
