**************************************************************************
***           Module main : affichage, programme principal             ***
**************************************************************************

	include	declare.s
	xdef	sortie,affiche_push_button,winner
	xdef	affiche_nouveau,affiche_score,affiche_winner
	
	xref	nouveau,jeux,init_box,score
	xref	initansi,locate
	xref	clear,gras,normal,inverse,souligne,clignote
	xref	partie,initirq,temps

**************************************************************************
	sect	prog,,c


	jsr	initansi
	jsr	presentation
	jsr	init_box
	
	move.b	#0,partie	# Il n'y a pas de partie en cours
	jsr	initirq
attend	cmp.b	#1,partie	# On attend un appuit sur le boutton poussoir
	bne	attend
	
	bra	jeux

**************************************************************************

* Affichage d'une page de prsentation
presentation
	jsr	clear
	jsr	normal
	jsr	clignote
	jsr	gras
	jsr	souligne
	
	move.b	#9,-(SP)
	move.b	#32,-(SP)
	jsr	locate
	lea	str_box,A5
	jsr	pdata

	jsr	normal
	jsr	gras

	move.b	#1,-(SP)
	move.b	#1,-(SP)
	jsr	locate
	lea	str_hans,a5
	jsr	pdata

	move.b	#2,-(SP)
	move.b	#0,-(SP)
	jsr	locate
	lea	str_sun,a5
	jsr	pdata

	move.b	#11,-(SP)
	move.b	#24,-(SP)
	jsr	locate
	lea	str_projet,a5
	jsr	pdata

	move.b	#1,-(SP)
	move.b	#72,-(SP)
	jsr	locate
	lea	str_date,a5
	jsr	pdata
	
	move.b	#0,-(SP)
	move.b	#0,-(SP)
	jsr	locate
	
	add.l	#24,SP
	rts


* Affichage avant chaque niveau
affiche_nouveau

	* Initialisation des variables
	move.l	#$20203004,aff_sc	* Score  afficher =  0

	* Affichage
	jsr	clear
	jsr	normal
	jsr	gras
	
	move.b	#1,-(SP)
	move.b	#60,-(SP)
	jsr	locate
	lea	str_move,A5
	jsr	pdata

	jsr	souligne
	move.b	#3,-(SP)
	move.b	#32,-(SP)
	jsr	locate
	add.l	#8,SP
	lea	str_box,A5
	jsr	pdata

	jsr	affiche_score
	rts

* affiche "winner"
affiche_winner
	jsr	normal
	jsr	gras
	move.b	#18,-(SP)
	move.b	#34,-(SP)
	jsr	locate
	add.l	#4,SP
	lea	str_winner,a5
	jsr	pdata
	rts

* affiche "push button"
affiche_push_button
	jsr	inverse
	jsr	clignote
	move.b	#21,-(SP)
	move.b	#31,-(SP)
	jsr	locate
	add.l	#4,SP
	lea	str_push_button,a5
	jsr	pdata
	rts

* Quand on a tout gagn...
winner
	jsr	clear
	jsr	normal
	jsr	gras
	move.b	#11,-(SP)
	move.b	#22,-(SP)
	jsr	locate
	add.l	#4,SP
	lea	str_master,a5
	jsr	pdata

	move.b	#4,partie
*attend2	cmp.b	#1,partie
*	bne	attend2
	jsr	inca
	
	bra	sortie


* Affichage du score
affiche_score
	movem.l	d0-d2,-(SP)
	
	move.w	#2,d2
	lea	aff_sc,a5
	clr.l	d1
	move.w	score,d1
	* On construit la chaine aff_sc  afficher
aff1
	cmp.b	#0,d1
	beq	aff2
	clr.l	d0
	move.w	d1,d0
	divu	#10,d0
	move.w	d0,d1
	swap	d0
	add.b	#$30,d0
	move.b	d0,(a5,d2)
	subi.b	#1,d2
	bra	aff1
	* On affiche la chaine aff_sc
aff2
	jsr	normal
	jsr	gras
	move.b	#1,-(SP)
	move.b	#70,-(SP)
	jsr	locate
	add.l	#4,SP
 	jsr	pdata
	jsr	inverse
	movem.l	(SP)+,d0-d2
	rts

	
sortie	jsr	normal
	jsr	clear
	jmp	mloop


**************************************************************************
	sect	data,,d

aff_sc	ds.l	1

* Chaines de caractres  afficher
str_box		dc.b	' ','S','O','C','O','B','A','N',' ',04
str_sun		dc.b    'L','E','V','A','N','T',' '
		dc.b	'S','t','e','p','h','a','n','e',04
str_hans	dc.b	'L','A','U','R','E','N','T',' ','J','e','a','n',04
str_projet	dc.b	'(','P','r','o','j','e','t',' ','a','s','s','e','m','b'
		dc.b	'l','e','u','r',' ','6','8','0','1','0',')',04
str_date	dc.b    'J','u','i','n',' ','1','9','9','8',04
str_move	dc.b	'M','o','v','e','s',' ',':',04
str_winner	dc.b    'W','i','n','n','e','r',04
str_push_button	dc.b    'P','u','s','h',' ','b','u','t','t','o','n',04
str_master	dc.b    'Y','o','u',' ','a','r','e',' ','t','h','e',' ','m','a'
		dc.b	's','t','e','r',' ','o','f',' ','b','o','x','e','s',04
