***
*** Module box : Jeu
***

	include	declare.s
	sect	prog,,c
	xdef	nouveau,box_status
	xref	levels,data
	xref	initansi,locate,gotoxy *,unite,dizaine
	xref	clear,gras,normal,inverse,souligne,clignote
	xref	partie,initirq,temps
	
* Constantes
TIME_OUT	equ	4000
NB_LVL	equ	1
DIM_Y	equ	21
DIM_X	equ	10
DEB_Y	equ	7
DEB_X	equ	27
GOD_BOX	equ	168 * 48
BAD_BOX	equ	255 * 79
VIDE	equ	32
PLACE	equ	183 * 42
MUR	equ	35

* Debut
	jsr	initansi
	lea	clear,a5
	jsr	pdata
	move.b	#0,numero
	move.b	#0,box_status
* 	jsr	initirq
* boucle	cmp.b	#1,partie
* 	bne	boucle

	jsr	nouveau

jeux	cmp.b	#2,partie
	bne	jeux2
	move.b	#1,partie
	jsr	nouveau	
	move.b	#1,box_status
jeux2	jsr	inca	* Fleche : ESC[A ESC[B ESC[C ESC[D
	cmp.b	#'Q',d0
	beq	sortie
	cmp.b	#'q',d0
	beq	sortie
	cmp.b	#'',d0
	bne	jeux2
	jsr	inca
	jsr	inca
	move.b	#0,box_status
	cmp.b	#'C',d0
	beq	droite
	cmp.b	#'D',d0
	beq	gauche
	cmp.b	#'B',d0
	beq	bas
	cmp.b	#'A',d0
	beq	haut
	bra	jeux

droite	move.b	y,y1
	move.b	y,y2
	move.b	x,d0
	add.b	#1,d0
	move.b	d0,x1	* case ou on veut aller : x1, y1
	add.b	#1,d0
	move.b	d0,x2	* case suivant celle o on veut aller : x2, y2
	bra	avancer

gauche	move.b	y,y1
	move.b	y,y2
	move.b	x,d0
	sub.b	#1,d0
	move.b	d0,x1
	sub.b	#1,d0
	move.b	d0,x2
	bra	avancer
	
haut	move.b	x,x1
	move.b	x,x2
	move.b	y,d0
	sub.b	#1,d0
	move.b	d0,y1
	sub.b	#1,d0
	move.b	d0,y2
	bra	avancer

bas	move.b	x,x1
	move.b	x,x2
	move.b	y,d0
	add.b	#1,d0
	move.b	d0,y1
	add.b	#1,d0
	move.b	d0,y2
	bra	avancer
	
avancer
	* On regarde si on peut aller sur la case suivante
	move.b	y1,d1
	move.b	x1,d2
	jsr	myx
	cmp.b	#VIDE,d0
	beq	ok
	cmp.b	#PLACE,d0
	beq	ok
	cmp.b	#MUR,d0
	beq	jeux
	
	* Ici, Il y'a une caisse sur la case
	move.b	d0,d3	* On sauvegarde d0

	* On regarde si on peut pousser la caisse
	move.b	y2,d1
	move.b	x2,d2
	jsr	myx
	cmp.b	#MUR,d0
	beq	jeux
	cmp.b	#GOD_BOX,d0
	beq	jeux
	cmp.b	#BAD_BOX,d0
	beq	jeux


	
	* Ici, on peut pousser la caisse
	* On augmente le score de 1
 	move.w	score,d5
 	add.w	#1,d5
 	move.w	d5,score


* 	lea	dizaine,a5
* 	move.b	(a5,d5),aff_sc+1
* 	lea	unite,a5
* 	move.b	(a5,d5),aff_sc+2

	move.b	#32,aff_sc
	move.b	#4,aff_sc+3
	
	move.b	#1,-(SP)
	move.b	#70,-(SP)
	jsr	locate
	add.l	#4,SP

	move.b	d0,d7
	
	lea	normal,a5
	jsr	pdata
	lea	gras,a5
	jsr	pdata
* 	lea	aff_sc,a5
* 	jsr	pdata
	lea	inverse,a5
	jsr	pdata

	move.b	d7,d0
	
	move.b	#VIDE,d4    * Caractre  afficher  l'emplacement de la caisse
	cmp.b	#BAD_BOX,d3 * La caisse etait-elle mal place ?
	beq	blanc1
	move.b	caisse,d5
	add.b	#1,d5
	move.b	d5,caisse
	move.b	#PLACE,d4   * Caractre  afficher  l'emplacement de la caisse

blanc1	move.b	d0,d5
	move.b	#BAD_BOX,d0 * Type de caisse  afficher
	cmp.b	#VIDE,d5    * La caisse va-t-elle mal se placer ?
	beq	blanc2
	move.b	caisse,d5
	subi.b	#1,d5
	move.b	d5,caisse
	move.b	#GOD_BOX,d0 * Type de caisse  afficher

blanc2
	* On affiche la caisse et on modifie la matrice
* 	move.b	y2,d1
* 	move.b	x2,d2
	jsr	loc
	jsr	set_myx
	jsr	outch

	* On efface la caisse et on modifie la matrice
	move.b	y1,d1
	move.b	x1,d2
	jsr	loc
	move.b	d4,d0
	jsr	set_myx
	jsr	outch
	bra	ok
	
ok

	* On place le curseur  la bonne position
	move.b	y1,d1
	move.b	x1,d2
	jsr	loc
	move.b	d1,y
	move.b	d2,x
	

	* On regarde si on a gagn
	cmp.b	#0,caisse
	bne	jeux

	
	move.b	numero,d0
	add.b	#1,d0
	move.b	d0,numero
	jsr	nouveau
	cmp.b	#NB_LVL+1,d0
	bne	jeux

sortie	lea	normal,A5
	jsr	pdata
	lea	clear,A5
	jsr	pdata
	jmp	mloop
	

* Procdure myx : renvoie s0.B=M(y,x) y=d1.b x=d2.b
myx	lea	level,a5
	clr.w	d0
	move.b	d1,d0
	mulu.w	#DIM_Y,d0
	and.w	#$FF,d2
	add.w	d2,d0
	move.b	(a5,d0),d0
	rts

* Procdure set_myx : Fait M(y,x)=d0.B y=d1.b x=d2.b
set_myx	move.w	d7,-(SP)
	lea	level,a5
	clr.w	d7
	move.b	d1,d7
	mulu.w	#DIM_Y,d7
	and.w	#$FF,d2
	add.w	d2,d7
	move.b	d0,(a5,d7)
	move.w	(SP)+,d7
	rts

* Procdure loc : met le curseur sur la ligne D1.B+5 et la colonne D2.B+20
* Utilise la sequence ascii [c;lH
* loc	
* 	*movem.l	d0-d2,-(SP)
* 	move.b	d0,-(SP)
* 	lea	dizaine,a5
* 	and.w	#$FF,d1
* 	and.w	#$FF,d2
* 	move.b	DEB_Y(a5,d1),gotoxy+2
* 	lea	unite,a5
* 	move.b	DEB_Y(a5,d1),gotoxy+3
* 	lea	dizaine,a5
* 	move.b	DEB_X(a5,d2),gotoxy+5
* 	lea	unite,a5
* 	move.b	DEB_X(a5,d2),gotoxy+6
* 	lea	gotoxy,a5
* 	jsr	pdata
* 	move.b	(SP)+,d0
* 	*movem.l	(SP)+,d0-d2
* 	rts

loc	movem.w	d0-d2,-(SP)
	add.b	#DEB_Y,d1
	add.b	#DEB_X,d2
	move.b	d1,-(SP)
	move.b	d2,-(SP)
	jsr	locate
	add.l	#4,SP
	movem.w	(SP)+,d0-d2
	rts

nouveau
* Procdure nouveau : Commence un nouveau jeu
	lea	normal,a5
	jsr	pdata		* Affichage normal
	lea	clear,A5
	jsr	pdata		* On efface l'cran

	lea	gras,A5
	jsr	pdata
	
	move.b	#1,-(SP)
	move.b	#60,-(SP)
	jsr	locate
	add.l	#4,SP
	lea	s_move,A5
	jsr	pdata

	lea	souligne,a5
	jsr	pdata
	move.b	#3,-(SP)
	move.b	#32,-(SP)
	jsr	locate
	add.l	#4,SP
	lea	s_box,A5
	jsr	pdata

	lea	normal,a5
	jsr	pdata
	lea	gras,A5
	jsr	pdata
	lea	inverse,A5
	jsr	pdata

	* Initialisation des variables
	move.w	#TIME_OUT,temps
	move.w	#0,score
	lea	data,a5
	clr.w	d0
	move.b	numero,d0
	mulu.w	#3,d0
	move.b	(a5,d0),y
	move.b	1(a5,d0),x
	move.b	2(a5,d0),caisse

	clr.w	d2
	move.b	numero,d2
	mulu.w	#DIM_X*DIM_Y,d2
	lea	level,a0
	lea	levels,a5
	move.w	#DIM_X*DIM_Y-1,d0
remplit	move.w	d2,d1
	add.w	d0,d1
	move.b	(a5,d1),(a0,d0)
	dbra	d0,remplit

	* On affiche le niveau
	lea	level,A0
	clr.b	d1
	clr.b	d2
bl	jsr	loc
	move.w	A0,A5
	JSR	pdata
	add.w	#DIM_Y,A0
	add.b	#1,d1
	cmp.b	#DIM_X,d1
	bne	bl

	* On place le curseur  la bonne position
	move.b	y,d1
	move.b	x,d2
	jsr	loc
	rts


	sect	data,,d

* Variables
level	ds.b DIM_X*DIM_Y * La matrice du level
y	ds.b 1	* ligne
x	ds.b 1	* colonne
caisse	ds.b 1  * nb de caisse  placer : caisse = 0 <==> on gagne
x1	ds.b 1	* colonne de la case o on veut aller
y1	ds.b 1	* ligne de la case o on veut aller
x2	ds.b 1	* colonne de la case o on veut pousser la caisse
y2	ds.b 1	* ligne de la case o on veut pousser la caisse
score	ds.w 1	* nb de fois ou on a deplac une caisse
numero	ds.b 1	* numro du level en cours
aff_sc	ds.b 4
box_status	ds.b 1

* Chaines de caractres  afficher
s_box	dc.b ' ','S','O','C','O','B','A','N',' ',04
s_move	dc.b 'M','o','v','e',' ',':',04
